Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 584)
+++ lemon/maps.h	(revision 440)
@@ -64,8 +64,7 @@
   class NullMap : public MapBase<K, V> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back a default constructed element.
@@ -104,8 +103,7 @@
     V _value;
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Default constructor
@@ -171,8 +169,7 @@
   class ConstMap<K, Const<V, v> > : public MapBase<K, V> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor.
@@ -206,8 +203,7 @@
   class IdentityMap : public MapBase<T, T> {
   public:
-    ///\e
-    typedef T Key;
-    ///\e
-    typedef T Value;
+    typedef MapBase<T, T> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back the given value without any modification.
@@ -250,8 +246,9 @@
   public:
 
+    typedef MapBase<int, V> Parent;
     /// Key type
-    typedef int Key;
+    typedef typename Parent::Key Key;
     /// Value type
-    typedef V Value;
+    typedef typename Parent::Value Value;
     /// Reference type
     typedef typename Vector::reference Reference;
@@ -357,5 +354,5 @@
   /// The simplest way of using this map is through the sparseMap()
   /// function.
-  template <typename K, typename V, typename Comp = std::less<K> >
+  template <typename K, typename V, typename Compare = std::less<K> >
   class SparseMap : public MapBase<K, V> {
     template <typename K1, typename V1, typename C1>
@@ -363,8 +360,9 @@
   public:
 
+    typedef MapBase<K, V> Parent;
     /// Key type
-    typedef K Key;
+    typedef typename Parent::Key Key;
     /// Value type
-    typedef V Value;
+    typedef typename Parent::Value Value;
     /// Reference type
     typedef Value& Reference;
@@ -376,5 +374,5 @@
   private:
 
-    typedef std::map<K, V, Comp> Map;
+    typedef std::map<K, V, Compare> Map;
     Map _map;
     Value _value;
@@ -492,13 +490,12 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M2::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M2::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     ComposeMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
 
-    ///\e
+    /// \e
     typename MapTraits<M1>::ConstReturnValue
     operator[](const Key &k) const { return _m1[_m2[k]]; }
@@ -549,13 +546,12 @@
     F _f;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<typename M1::Key, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     CombineMap(const M1 &m1, const M2 &m2, const F &f = F())
       : _m1(m1), _m2(m2), _f(f) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _f(_m1[k],_m2[k]); }
   };
@@ -620,12 +616,11 @@
     F _f;
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     FunctorToMap(const F &f = F()) : _f(f) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _f(k); }
   };
@@ -675,17 +670,16 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
-
-    typedef typename M::Key argument_type;
-    typedef typename M::Value result_type;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
+
+    typedef typename Parent::Key argument_type;
+    typedef typename Parent::Value result_type;
 
     /// Constructor
     MapToFunctor(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator()(const Key &k) const { return _m[k]; }
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]; }
   };
@@ -716,8 +710,7 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<typename M::Key, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -727,5 +720,5 @@
     ConvertMap(const M &m) : _m(m) {}
 
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]; }
   };
@@ -759,8 +752,7 @@
     M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -806,12 +798,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     AddMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]+_m2[k]; }
   };
@@ -855,12 +846,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     SubMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]-_m2[k]; }
   };
@@ -905,12 +895,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     MulMap(const M1 &m1,const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]*_m2[k]; }
   };
@@ -954,12 +943,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     DivMap(const M1 &m1,const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]/_m2[k]; }
   };
@@ -1005,8 +993,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1016,5 +1003,5 @@
     /// \param v The constant value.
     ShiftMap(const M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]+_v; }
   };
@@ -1036,8 +1023,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1047,7 +1033,7 @@
     /// \param v The constant value.
     ShiftWriteMap(M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]+_v; }
-    ///\e
+    /// \e
     void set(const Key &k, const Value &v) { _m.set(k, v-_v); }
   };
@@ -1108,8 +1094,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1119,5 +1104,5 @@
     /// \param v The constant value.
     ScaleMap(const M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _v*_m[k]; }
   };
@@ -1140,8 +1125,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1151,7 +1135,7 @@
     /// \param v The constant value.
     ScaleWriteMap(M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _v*_m[k]; }
-    ///\e
+    /// \e
     void set(const Key &k, const Value &v) { _m.set(k, v/_v); }
   };
@@ -1210,12 +1194,11 @@
     const M& _m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NegMap(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return -_m[k]; }
   };
@@ -1246,14 +1229,13 @@
     M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NegWriteMap(M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return -_m[k]; }
-    ///\e
+    /// \e
     void set(const Key &k, const Value &v) { _m.set(k, -v); }
   };
@@ -1301,12 +1283,11 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     AbsMap(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const {
       Value tmp = _m[k];
@@ -1357,8 +1338,7 @@
   class TrueMap : public MapBase<K, bool> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<K, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back \c true.
@@ -1395,8 +1375,7 @@
   class FalseMap : public MapBase<K, bool> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<K, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back \c false.
@@ -1441,12 +1420,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     AndMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]&&_m2[k]; }
   };
@@ -1490,12 +1468,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     OrMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]||_m2[k]; }
   };
@@ -1530,12 +1507,11 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NotMap(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return !_m[k]; }
   };
@@ -1557,14 +1533,13 @@
     M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NotWriteMap(M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return !_m[k]; }
-    ///\e
+    /// \e
     void set(const Key &k, bool v) { _m.set(k, !v); }
   };
@@ -1621,12 +1596,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     EqualMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]==_m2[k]; }
   };
@@ -1670,12 +1644,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     LessMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]<_m2[k]; }
   };
@@ -1733,6 +1706,6 @@
   /// function.
   ///
-  /// \tparam IT The type of the iterator.
-  /// \tparam KEY The key type of the map. The default value set
+  /// \tparam It The type of the iterator.
+  /// \tparam Ke The key type of the map. The default value set
   /// according to the iterator type should work in most cases.
   ///
@@ -1740,18 +1713,15 @@
   /// for the elements or the iterator should be an inserter iterator.
 #ifdef DOXYGEN
-  template <typename IT, typename KEY>
+  template <typename It, typename Ke>
 #else
-  template <typename IT,
-            typename KEY = typename _maps_bits::IteratorTraits<IT>::Value>
+  template <typename It,
+            typename Ke=typename _maps_bits::IteratorTraits<It>::Value>
 #endif
-  class LoggerBoolMap : public MapBase<KEY, bool> {
-  public:
-
-    ///\e
-    typedef KEY Key;
-    ///\e
+  class LoggerBoolMap {
+  public:
+    typedef It Iterator;
+
+    typedef Ke Key;
     typedef bool Value;
-    ///\e
-    typedef IT Iterator;
 
     /// Constructor
@@ -1816,33 +1786,21 @@
   /// @{
 
-  /// \brief Provides an immutable and unique id for each item in a graph.
-  ///
-  /// IdMap provides a unique and immutable id for each item of the
-  /// same type (\c Node, \c Arc or \c Edge) in a graph. This id is 
-  ///  - \b unique: different items get different ids,
-  ///  - \b immutable: the id of an item does not change (even if you
-  ///    delete other nodes).
-  ///
-  /// Using this map you get access (i.e. can read) the inner id values of
-  /// the items stored in the graph, which is returned by the \c id()
-  /// function of the graph. This map can be inverted with its member
+  /// Provides an immutable and unique id for each item in the graph.
+
+  /// The IdMap class provides a unique and immutable id for each item of the
+  /// same type (e.g. node) in the graph. This id is <ul><li>\b unique:
+  /// different items (nodes) get different ids <li>\b immutable: the id of an
+  /// item (node) does not change (even if you delete other nodes).  </ul>
+  /// Through this map you get access (i.e. can read) the inner id values of
+  /// the items stored in the graph. This map can be inverted with its member
   /// class \c InverseMap or with the \c operator() member.
   ///
-  /// \tparam GR The graph type.
-  /// \tparam K The key type of the map (\c GR::Node, \c GR::Arc or
-  /// \c GR::Edge).
-  ///
-  /// \see RangeIdMap
-  template <typename GR, typename K>
-  class IdMap : public MapBase<K, int> {
-  public:
-    /// The graph type of IdMap.
-    typedef GR Graph;
-    /// The key type of IdMap (\c Node, \c Arc or \c Edge).
-    typedef K Item;
-    /// The key type of IdMap (\c Node, \c Arc or \c Edge).
-    typedef K Key;
-    /// The value type of IdMap.
+  template <typename _Graph, typename _Item>
+  class IdMap {
+  public:
+    typedef _Graph Graph;
     typedef int Value;
+    typedef _Item Item;
+    typedef _Item Key;
 
     /// \brief Constructor.
@@ -1856,7 +1814,7 @@
     int operator[](const Item& item) const { return _graph->id(item);}
 
-    /// \brief Gives back the \e item by its id.
-    ///
-    /// Gives back the \e item by its id.
+    /// \brief Gives back the item by its id.
+    ///
+    /// Gives back the item by its id.
     Item operator()(int id) { return _graph->fromId(id, Item()); }
 
@@ -1866,7 +1824,7 @@
   public:
 
-    /// \brief This class represents the inverse of its owner (IdMap).
-    ///
-    /// This class represents the inverse of its owner (IdMap).
+    /// \brief The class represents the inverse of its owner (IdMap).
+    ///
+    /// The class represents the inverse of its owner (IdMap).
     /// \see inverse()
     class InverseMap {
@@ -1886,4 +1844,5 @@
       ///
       /// Gives back the given item from its id.
+      ///
       Item operator[](int id) const { return _graph->fromId(id, Item());}
 
@@ -1896,11 +1855,12 @@
     /// Gives back the inverse of the IdMap.
     InverseMap inverse() const { return InverseMap(*_graph);}
-  };
-
-
-  /// \brief General cross reference graph map type.
-
-  /// This class provides simple invertable graph maps.
-  /// It wraps an arbitrary \ref concepts::ReadWriteMap "ReadWriteMap"
+
+  };
+
+
+  /// \brief General invertable graph-map type.
+
+  /// This type provides simple invertable graph-maps.
+  /// The InvertableMap wraps an arbitrary ReadWriteMap
   /// and if a key is set to a new value then store it
   /// in the inverse map.
@@ -1909,36 +1869,33 @@
   /// with stl compatible forward iterator.
   ///
-  /// \tparam GR The graph type.
-  /// \tparam K The key type of the map (\c GR::Node, \c GR::Arc or
-  /// \c GR::Edge).
-  /// \tparam V The value type of the map.
+  /// \tparam _Graph The graph type.
+  /// \tparam _Item The item type of the graph.
+  /// \tparam _Value The value type of the map.
   ///
   /// \see IterableValueMap
-  template <typename GR, typename K, typename V>
-  class CrossRefMap
-    : protected ItemSetTraits<GR, K>::template Map<V>::Type {
+  template <typename _Graph, typename _Item, typename _Value>
+  class InvertableMap
+    : protected ItemSetTraits<_Graph, _Item>::template Map<_Value>::Type {
   private:
 
-    typedef typename ItemSetTraits<GR, K>::
-      template Map<V>::Type Map;
-
-    typedef std::map<V, K> Container;
+    typedef typename ItemSetTraits<_Graph, _Item>::
+    template Map<_Value>::Type Map;
+    typedef _Graph Graph;
+
+    typedef std::map<_Value, _Item> Container;
     Container _inv_map;
 
   public:
 
-    /// The graph type of CrossRefMap.
-    typedef GR Graph;
-    /// The key type of CrossRefMap (\c Node, \c Arc or \c Edge).
-    typedef K Item;
-    /// The key type of CrossRefMap (\c Node, \c Arc or \c Edge).
-    typedef K Key;
-    /// The value type of CrossRefMap.
-    typedef V Value;
+    /// The key type of InvertableMap (Node, Arc, Edge).
+    typedef typename Map::Key Key;
+    /// The value type of the InvertableMap.
+    typedef typename Map::Value Value;
 
     /// \brief Constructor.
     ///
-    /// Construct a new CrossRefMap for the given graph.
-    explicit CrossRefMap(const Graph& graph) : Map(graph) {}
+    /// Construct a new InvertableMap for the graph.
+    ///
+    explicit InvertableMap(const Graph& graph) : Map(graph) {}
 
     /// \brief Forward iterator for values.
@@ -1946,8 +1903,9 @@
     /// This iterator is an stl compatible forward
     /// iterator on the values of the map. The values can
-    /// be accessed in the <tt>[beginValue, endValue)</tt> range.
+    /// be accessed in the [beginValue, endValue) range.
+    ///
     class ValueIterator
       : public std::iterator<std::forward_iterator_tag, Value> {
-      friend class CrossRefMap;
+      friend class InvertableMap;
     private:
       ValueIterator(typename Container::const_iterator _it)
@@ -1978,5 +1936,5 @@
     /// Returns an stl compatible iterator to the
     /// first value of the map. The values of the
-    /// map can be accessed in the <tt>[beginValue, endValue)</tt>
+    /// map can be accessed in the [beginValue, endValue)
     /// range.
     ValueIterator beginValue() const {
@@ -1988,5 +1946,5 @@
     /// Returns an stl compatible iterator after the
     /// last value of the map. The values of the
-    /// map can be accessed in the <tt>[beginValue, endValue)</tt>
+    /// map can be accessed in the [beginValue, endValue)
     /// range.
     ValueIterator endValue() const {
@@ -1994,7 +1952,7 @@
     }
 
-    /// \brief Sets the value associated with the given key.
-    ///
-    /// Sets the value associated with the given key.
+    /// \brief The setter function of the map.
+    ///
+    /// Sets the mapped value.
     void set(const Key& key, const Value& val) {
       Value oldval = Map::operator[](key);
@@ -2007,7 +1965,7 @@
     }
 
-    /// \brief Returns the value associated with the given key.
-    ///
-    /// Returns the value associated with the given key.
+    /// \brief The getter function of the map.
+    ///
+    /// It gives back the value associated with the key.
     typename MapTraits<Map>::ConstReturnValue
     operator[](const Key& key) const {
@@ -2025,7 +1983,7 @@
   protected:
 
-    /// \brief Erase the key from the map and the inverse map.
-    ///
-    /// Erase the key from the map and the inverse map. It is called by the
+    /// \brief Erase the key from the map.
+    ///
+    /// Erase the key to the map. It is called by the
     /// \c AlterationNotifier.
     virtual void erase(const Key& key) {
@@ -2038,7 +1996,7 @@
     }
 
-    /// \brief Erase more keys from the map and the inverse map.
-    ///
-    /// Erase more keys from the map and the inverse map. It is called by the
+    /// \brief Erase more keys from the map.
+    ///
+    /// Erase more keys from the map. It is called by the
     /// \c AlterationNotifier.
     virtual void erase(const std::vector<Key>& keys) {
@@ -2053,7 +2011,7 @@
     }
 
-    /// \brief Clear the keys from the map and the inverse map.
-    ///
-    /// Clear the keys from the map and the inverse map. It is called by the
+    /// \brief Clear the keys from the map and inverse map.
+    ///
+    /// Clear the keys from the map and inverse map. It is called by the
     /// \c AlterationNotifier.
     virtual void clear() {
@@ -2067,22 +2025,22 @@
     ///
     /// The inverse of this map. The subscript operator of the map
-    /// gives back the item that was last assigned to the value.
+    /// gives back always the item what was last assigned to the value.
     class InverseMap {
     public:
-      /// \brief Constructor
+      /// \brief Constructor of the InverseMap.
       ///
       /// Constructor of the InverseMap.
-      explicit InverseMap(const CrossRefMap& inverted)
+      explicit InverseMap(const InvertableMap& inverted)
         : _inverted(inverted) {}
 
       /// The value type of the InverseMap.
-      typedef typename CrossRefMap::Key Value;
+      typedef typename InvertableMap::Key Value;
       /// The key type of the InverseMap.
-      typedef typename CrossRefMap::Value Key;
+      typedef typename InvertableMap::Value Key;
 
       /// \brief Subscript operator.
       ///
-      /// Subscript operator. It gives back the item
-      /// that was last assigned to the given value.
+      /// Subscript operator. It gives back always the item
+      /// what was last assigned to the value.
       Value operator[](const Key& key) const {
         return _inverted(key);
@@ -2090,10 +2048,10 @@
 
     private:
-      const CrossRefMap& _inverted;
+      const InvertableMap& _inverted;
     };
 
-    /// \brief It gives back the read-only inverse map.
-    ///
-    /// It gives back the read-only inverse map.
+    /// \brief It gives back the just readable inverse map.
+    ///
+    /// It gives back the just readable inverse map.
     InverseMap inverse() const {
       return InverseMap(*this);
@@ -2102,46 +2060,39 @@
   };
 
-  /// \brief Provides continuous and unique ID for the
-  /// items of a graph.
-  ///
-  /// RangeIdMap provides a unique and continuous
-  /// ID for each item of a given type (\c Node, \c Arc or
-  /// \c Edge) in a graph. This id is
-  ///  - \b unique: different items get different ids,
-  ///  - \b continuous: the range of the ids is the set of integers
-  ///    between 0 and \c n-1, where \c n is the number of the items of
-  ///    this type (\c Node, \c Arc or \c Edge).
-  ///  - So, the ids can change when deleting an item of the same type.
-  ///
-  /// Thus this id is not (necessarily) the same as what can get using
-  /// the \c id() function of the graph or \ref IdMap.
-  /// This map can be inverted with its member class \c InverseMap,
-  /// or with the \c operator() member.
-  ///
-  /// \tparam GR The graph type.
-  /// \tparam K The key type of the map (\c GR::Node, \c GR::Arc or
-  /// \c GR::Edge).
-  ///
-  /// \see IdMap
-  template <typename GR, typename K>
-  class RangeIdMap
-    : protected ItemSetTraits<GR, K>::template Map<int>::Type {
-
-    typedef typename ItemSetTraits<GR, K>::template Map<int>::Type Map;
-
-  public:
-    /// The graph type of RangeIdMap.
-    typedef GR Graph;
-    /// The key type of RangeIdMap (\c Node, \c Arc or \c Edge).
-    typedef K Item;
-    /// The key type of RangeIdMap (\c Node, \c Arc or \c Edge).
-    typedef K Key;
-    /// The value type of RangeIdMap.
-    typedef int Value;
+  /// \brief Provides a mutable, continuous and unique descriptor for each
+  /// item in the graph.
+  ///
+  /// The DescriptorMap class provides a unique and continuous (but mutable)
+  /// descriptor (id) for each item of the same type (e.g. node) in the
+  /// graph. This id is <ul><li>\b unique: different items (nodes) get
+  /// different ids <li>\b continuous: the range of the ids is the set of
+  /// integers between 0 and \c n-1, where \c n is the number of the items of
+  /// this type (e.g. nodes) (so the id of a node can change if you delete an
+  /// other node, i.e. this id is mutable).  </ul> This map can be inverted
+  /// with its member class \c InverseMap, or with the \c operator() member.
+  ///
+  /// \tparam _Graph The graph class the \c DescriptorMap belongs to.
+  /// \tparam _Item The Item is the Key of the Map. It may be Node, Arc or
+  /// Edge.
+  template <typename _Graph, typename _Item>
+  class DescriptorMap
+    : protected ItemSetTraits<_Graph, _Item>::template Map<int>::Type {
+
+    typedef _Item Item;
+    typedef typename ItemSetTraits<_Graph, _Item>::template Map<int>::Type Map;
+
+  public:
+    /// The graph class of DescriptorMap.
+    typedef _Graph Graph;
+
+    /// The key type of DescriptorMap (Node, Arc, Edge).
+    typedef typename Map::Key Key;
+    /// The value type of DescriptorMap.
+    typedef typename Map::Value Value;
 
     /// \brief Constructor.
     ///
-    /// Constructor.
-    explicit RangeIdMap(const Graph& gr) : Map(gr) {
+    /// Constructor for descriptor map.
+    explicit DescriptorMap(const Graph& _graph) : Map(_graph) {
       Item it;
       const typename Map::Notifier* nf = Map::notifier();
@@ -2154,5 +2105,5 @@
   protected:
 
-    /// \brief Adds a new key to the map.
+    /// \brief Add a new key to the map.
     ///
     /// Add a new key to the map. It is called by the
@@ -2244,14 +2195,14 @@
     }
 
-    /// \brief Gives back the \e RangeId of the item
-    ///
-    /// Gives back the \e RangeId of the item.
+    /// \brief Gives back the \e descriptor of the item.
+    ///
+    /// Gives back the mutable and unique \e descriptor of the map.
     int operator[](const Item& item) const {
       return Map::operator[](item);
     }
 
-    /// \brief Gives back the item belonging to a \e RangeId
-    /// 
-    /// Gives back the item belonging to a \e RangeId.
+    /// \brief Gives back the item by its descriptor.
+    ///
+    /// Gives back th item by its descriptor.
     Item operator()(int id) const {
       return _inv_map[id];
@@ -2264,26 +2215,25 @@
 
   public:
-
-    /// \brief The inverse map type of RangeIdMap.
-    ///
-    /// The inverse map type of RangeIdMap.
+    /// \brief The inverse map type of DescriptorMap.
+    ///
+    /// The inverse map type of DescriptorMap.
     class InverseMap {
     public:
-      /// \brief Constructor
+      /// \brief Constructor of the InverseMap.
       ///
       /// Constructor of the InverseMap.
-      explicit InverseMap(const RangeIdMap& inverted)
+      explicit InverseMap(const DescriptorMap& inverted)
         : _inverted(inverted) {}
 
 
       /// The value type of the InverseMap.
-      typedef typename RangeIdMap::Key Value;
+      typedef typename DescriptorMap::Key Value;
       /// The key type of the InverseMap.
-      typedef typename RangeIdMap::Value Key;
+      typedef typename DescriptorMap::Value Key;
 
       /// \brief Subscript operator.
       ///
       /// Subscript operator. It gives back the item
-      /// that the descriptor currently belongs to.
+      /// that the descriptor belongs to currently.
       Value operator[](const Key& key) const {
         return _inverted(key);
@@ -2298,5 +2248,5 @@
 
     private:
-      const RangeIdMap& _inverted;
+      const DescriptorMap& _inverted;
     };
 
@@ -2309,34 +2259,32 @@
   };
 
-  /// \brief Map of the source nodes of arcs in a digraph.
-  ///
-  /// SourceMap provides access for the source node of each arc in a digraph,
-  /// which is returned by the \c source() function of the digraph.
-  /// \tparam GR The digraph type.
+  /// \brief Returns the source of the given arc.
+  ///
+  /// The SourceMap gives back the source Node of the given arc.
   /// \see TargetMap
-  template <typename GR>
+  template <typename Digraph>
   class SourceMap {
   public:
 
-    ///\e
-    typedef typename GR::Arc Key;
-    ///\e
-    typedef typename GR::Node Value;
+    typedef typename Digraph::Node Value;
+    typedef typename Digraph::Arc Key;
 
     /// \brief Constructor
     ///
-    /// Constructor.
+    /// Constructor
     /// \param digraph The digraph that the map belongs to.
-    explicit SourceMap(const GR& digraph) : _graph(digraph) {}
-
-    /// \brief Returns the source node of the given arc.
-    ///
-    /// Returns the source node of the given arc.
+    explicit SourceMap(const Digraph& digraph) : _digraph(digraph) {}
+
+    /// \brief The subscript operator.
+    ///
+    /// The subscript operator.
+    /// \param arc The arc
+    /// \return The source of the arc
     Value operator[](const Key& arc) const {
-      return _graph.source(arc);
+      return _digraph.source(arc);
     }
 
   private:
-    const GR& _graph;
+    const Digraph& _digraph;
   };
 
